<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
  </head>
  <body>
    <script>
      // Функция может возвращать значения.
      // function functWithReturnedValue() {
      //   return "value";
      // }

      // console.log(functWithReturnedValue());
      // let b = 13;
      // function funcWithVarInside() {
      //   // локальная переменная, снаружи функции ее не видно

      //   let a = 12;
      //   return a * b;
      // }

      // console.log(funcWithVarInside());

      // console.log(funcWithVarInside());

      //   Переменная внутри функции "живет" в момент вызова функции
      //   Как только функция отработала - переменная а исчезает из памяти

      // Давайте попробуем создать счетчик

      // let a = 0;

      // function count() {
      //   // увеличиеваем на 1
      //   // a = a + 1;
      //   a++;
      //   // возвращаем а
      //   return a;
      // }

      // console.log(count());
      // console.log(count());

      // Какая проблема этого кода?

      // попробуем переписать
      // function count1() {
      //   // увеличиеваем на 1
      //   let a = 0;
      //   a++;
      //   // возвращаем а
      //   return a;
      // }

      // console.log(count1()); // 1
      // console.log(count1()); // 1

      //  А еще функция может возвращать другую функцию
      // function functWithReturnedFunction() {
      //   return function () {
      //     console.log("value inside internal function");
      //   };
      // }

      //   // в консоль ничего не выведется.
      // functWithReturnedFunction(); // function() {

      // // }

      //   // Чтоб внутренняя функция отработала нужно результат
      //   // присвоить в переменную. Там будет функция и мы ее вызовем
      // const varForInternalFunction = functWithReturnedFunction();

      //   // Вызываем
      // varForInternalFunction();

      //   // Другой пример с параметром
      // function functWithReturnedFunctionWithParam(param) {
      //   return function () {
      //     console.log(param);
      //   };
      // }

      //   //   Функция functWithReturnedFunctionWithParam отработала уже
      // const varForInternalFunctionWithParam =
      //   functWithReturnedFunctionWithParam("Ira");

      //   // а внутренняя функция вызвана позже.
      //   // Первая функция уже отработала, но параметр Ira все равно запомнился
      //   // и функция вызывается с ним
      // varForInternalFunctionWithParam();

      //   // тоже самое
      // const varForInternalFunctionWithParam1 =
      //   functWithReturnedFunctionWithParam("Nastya");
      // varForInternalFunctionWithParam1();

      //   Функция возвращает функцию
      // let name = "John";

      // function makeWorker() {
      //   //   объявляем переменную
      //   let name = "Pete";

      //   return function () {
      //     console.log(name);
      //   };
      // }

      //   внутренняя функция запомнила что name = 'Pete'
      // const internalMakeWorker = makeWorker();
      // internalMakeWorker();
      // makeWorker()();

      //   Сделаем счетчик с помощью замыканий
      // function counter() {
      //   let a = 0;

      //   return function () {
      //     console.log(a + " this is a");
      //     a++;
      //     return a;
      //   };
      // }

      const countOne = counter();

      console.log(countOne());
      console.log(countOne());

      //   Каждый раз, когда движок JavaScript создаёт контекст выполнения,
      //   чтобы выполнить функцию или глобальный код, он также создаёт новое лексическое окружение,
      //   чтобы хранить переменную определенную в этой функции во время её выполнения.
      //   Лексическое окружение это структура данных, которая хранит информацию по идентификаторам
      //   переменных. Тут идентификатор обозначает имя переменных/функций,
      //   а переменная настоящий объект[включая тип функции] или примитивное значение.
      //       lexicalEnvironment = {
      //   environmentRecord: {
      //     <identifier> : <value>,
      //     <identifier> : <value>
      //   }
      //   outer: < Reference to the parent lexical environment>
      // }
      // let a = "Hello World!";
      // function first() {
      //   let b = 25;
      //   console.log("Inside first function");

      //   return function() {
      //     console.log(b);

      //   }
      // }
      // first();
      // console.log("Inside global execution context");

      //       globalLexicalEnvironment = {
      //          environmentRecord: {
      //          a     : 'Hello World!',
      //       first : < reference to function object >
      //   }
      //   outer: null
      // // }
      //       functionLexicalEnvironment = {
      //   environmentRecord: {
      //       b    : 25,
      //   }
      //   outer: <globalLexicalEnvironment>
      // }
      //   когда функция выполняется, её лексическое окружение может или не может быть удалено
      //   из памяти, в зависимости от того, ссылается ли на это лексическое окружение
      //   другое лексическое окружение.
    </script>
  </body>
</html>
